/// <reference types="node" />
import TXList from './TXList';
export interface IReadonlyNameInfo {
    readonly [name: string]: {
        readonly txid: string;
        readonly pubKey: Buffer;
        readonly expires: number;
    };
}
/**
 * Function will find a lock transaction in txs
 * @param txid a list of all transactions with a given address as an input
 * or output
 * @param servicePubKey the services public key stored in a buffer
 * @param curHeight the current height of the blockchain (number of blocks)
 * @return IReadonlyNameInfo returns a name, txid, pubkey and the block that the
 * name name expires in
 */
declare function extractInfo(txs: TXList, servicePubKey: Buffer, curHeight: number): IReadonlyNameInfo;
export { extractInfo };
