"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var bcoin_1 = require("bcoin");
function bech32Encode(pubKey, network) {
    var hrp;
    if (network === 'main') {
        hrp = 'pk';
    }
    else {
        hrp = 'tp';
    }
    return bcoin_1.utils.bech32.encode(hrp, 0, pubKey);
}
exports.bech32Encode = bech32Encode;
function bech32Decode(data) {
    var decoded = bcoin_1.utils.bech32.decode(data);
    var pubKey = decoded.hash;
    var hrp = decoded.hrp;
    var network;
    if (hrp === 'pk') {
        network = 'main';
    }
    else if (hrp === 'tp') {
        network = 'testnet';
    }
    else {
        return null;
    }
    return {
        pubKey: pubKey,
        network: network,
    };
}
exports.bech32Decode = bech32Decode;
