"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var child_process = require("child_process");
var bcoin_1 = require("bcoin");
var txs_1 = require("./lib/txs");
var wif = 'cTV3FM3RfiFwmHfX6x43g4Xp8qeLbi15pNELuWF9sV3renVZ63nB';
var ring = bcoin_1.keyring.fromSecret(wif);
var addr = ring.getAddress().toBase58('testnet');
var serviceWif = 'cRMzGH4towfYVCref4Qz9iyfKaRkvfgVvZ2qk4hExMR7FcpzzVg6';
var serviceRing = bcoin_1.keyring.fromSecret(serviceWif);
var servicePubKey = serviceRing.getPublicKey();
// console.log(serviceRing.getAddress().toBase58('testnet'));
console.log(ring.getPublicKey().toString('hex'));
console.log(servicePubKey.toString('hex'));
child_process.exec("bitcoin-cli -regtest listunspent 0 9999999 \"[\\\"" + addr + "\\\"]\"", function (err, stdout, stderr) {
    if (err) {
        console.log(err);
        // node couldn't execute the command
        return;
    }
    // the *entire* stdout and stderr (buffered)
    // console.log(`stdout: ${stdout}`);
    // console.log(`stderr: ${stderr}`);
    var unspentData = JSON.parse(stdout);
    // console.log(unspentData);
    var coins = [];
    for (var _i = 0, unspentData_1 = unspentData; _i < unspentData_1.length; _i++) {
        var utxo = unspentData_1[_i];
        var amt = bcoin_1.amount.fromBTC(utxo.amount).toSatoshis(true);
        // console.log(typeof(amt));
        // console.log(amt as any instanceof Amount);
        var coinOpts = {
            version: 1,
            height: -1,
            value: amt,
            script: bcoin_1.script.fromRaw(utxo.scriptPubKey, 'hex'),
            hash: bcoin_1.util.revHex(utxo.txid),
            index: utxo.vout,
        };
        coins.push(new bcoin_1.coin(coinOpts));
    }
    console.log(addr);
    var commitFee = 500000;
    var registerFee = 500000;
    var escrowFee = 1000000;
    var feeRate = 11000;
    child_process.exec('bitcoin-cli -regtest getblockchaininfo', function (err2, stdout2, stderr2) {
        if (err2) {
            console.log(err2);
            // node couldn't execute the command
            return;
        }
        var blockchainData = JSON.parse(stdout2);
        // console.log(blockchainData);
        var height = blockchainData.blocks;
        // console.log(height, typeof height);
        var name = 'colin';
        var locktime = height + 10;
        var commitTX = txs_1.genCommitTx(coins, name, locktime, commitFee, registerFee, escrowFee, feeRate, ring, servicePubKey);
        console.log('Commit');
        console.log(commitTX.toRaw().toString('hex'));
        var lockTX = txs_1.genLockTx(commitTX, name, registerFee, escrowFee, feeRate, ring, servicePubKey, locktime);
        console.log('Lock');
        console.log(lockTX.toRaw().toString('hex'));
        var serviceUnlockTX = txs_1.genUnlockTx(lockTX, commitTX, feeRate * 2, true, serviceRing, ring.getPublicKey());
        console.log('Service Unlock');
        console.log(serviceUnlockTX.toRaw().toString('hex'));
        var userUnlockTX = txs_1.genUnlockTx(lockTX, commitTX, feeRate, false, ring, servicePubKey);
        console.log('User Unlock');
        console.log(userUnlockTX.toRaw().toString('hex'));
    });
});
